unit AxisDemoU;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, DMPlot, StdCtrls;

type
  TMainForm = class(TForm)
    ITCheckBox: TCheckBox;
    ZeroCheckBox: TCheckBox;
    GridCheckBox: TCheckBox;
    procedure FormDestroy(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormPaint(Sender: TObject);
    procedure GridCheckBoxClick(Sender: TObject);
    procedure ITCheckBoxClick(Sender: TObject);
    procedure ZeroCheckBoxClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    Axis: TAxis;
  end;

var
  MainForm: TMainForm;
  margins: integer;

implementation

{$R *.dfm}

procedure TMainForm.FormDestroy(Sender: TObject);
begin
  FreeAndNil(Axis);
end;

procedure TMainForm.FormCreate(Sender: TObject);
begin
  Axis:=TAxis.Create(nil);
  margins:=Constraints.MinHeight div 2;
  ITCheckBox.Checked:=Axis.InnerTicks;
  ZeroCheckBox.Checked:=Axis.Min=Axis.Max;
  GridCheckBox.Checked:=Axis.ShowGrid;
  // now setup axis dynamically
  Axis.Title:='X axis';
  Axis.GridPen.Style:=psDot;
  Axis.GridPen.Color:=clGray;
end;

procedure TMainForm.FormPaint(Sender: TObject);
begin
  // draw background
  Canvas.Brush.Style:=bsSolid;
  Canvas.Brush.Color:=Color;
  Canvas.FillRect(GetClientRect);
  // draw axis
  Axis.Paint(Canvas, margins, ClientHeight-margins, 
    ClientWidth-margins*2, ClientHeight-margins*2, axBottom);
end;

procedure TMainForm.GridCheckBoxClick(Sender: TObject);
begin
  Axis.ShowGrid:=GridCheckBox.Checked;
  Refresh;
end;

procedure TMainForm.ITCheckBoxClick(Sender: TObject);
begin
  Axis.InnerTicks:=ITCheckBox.Checked;
  Refresh;
end;

procedure TMainForm.ZeroCheckBoxClick(Sender: TObject);
begin
  if ZeroCheckBox.Checked 
  then Axis.Max:=Axis.Min
  else Axis.Max:=10;
  Refresh;
end;

end.
